package com.ynet.life.security.crypto;

import java.security.Security;
import javax.crypto.Cipher;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.PBEKeySpec;
import javax.crypto.spec.SecretKeySpec;
import org.apache.commons.codec.binary.Base64;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class SymmetricCryptoHelper {

   private static final String KEY_ALGORITHM = "AES";
   private static final String CIPHER_ALGORITHM = "PBKDF2WithHmacSHA1";
   private static final String CIPHER_PADDING = "AES/CTR/PKCS5Padding";
   private static final int KEY_SIZE = 128;


   static {
      try {
         if(Security.getProvider("BC") == null) {
            Security.addProvider(new BouncyCastleProvider());
            return;
         }
      } catch (Exception var1) {
         System.err.println("Cannot load security provider: BC \n" + var1.getMessage());
      }

   }

   public static String encryptData(String encryptedData, String aEncryptingData) throws Exception {
      if(encryptedData != null && aEncryptingData != null) {
         byte[] cipher = new byte[]{(byte)101, (byte)43, (byte)115, (byte)117, (byte)37, (byte)42, (byte)52, (byte)79};
         byte[] iv = new byte[]{(byte)56, (byte)55, (byte)54, (byte)53, (byte)52, (byte)51, (byte)50, (byte)49, (byte)56, (byte)55, (byte)54, (byte)53, (byte)52, (byte)51, (byte)50, (byte)49};
         SecretKeyFactory factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA1");
         PBEKeySpec encryptedData1 = new PBEKeySpec(encryptedData.toCharArray(), cipher, 1024, 128);
         SecretKeySpec encryptedData2 = new SecretKeySpec(factory.generateSecret(encryptedData1).getEncoded(), "AES");
         Cipher cipher1;
         (cipher1 = Cipher.getInstance("AES/CTR/PKCS5Padding", "BC")).init(1, encryptedData2, new IvParameterSpec(iv));
         byte[] encryptedData3 = cipher1.doFinal(aEncryptingData.getBytes());
         return new String(Base64.encodeBase64(encryptedData3), "UTF-8");
      } else {
         return null;
      }
   }

   public static String decryptData(String decryptedData, String aDecryptingData) throws Exception {
      if(decryptedData != null && aDecryptingData != null) {
         byte[] cipher = new byte[]{(byte)101, (byte)43, (byte)115, (byte)117, (byte)37, (byte)42, (byte)52, (byte)79};
         byte[] iv = new byte[]{(byte)56, (byte)55, (byte)54, (byte)53, (byte)52, (byte)51, (byte)50, (byte)49, (byte)56, (byte)55, (byte)54, (byte)53, (byte)52, (byte)51, (byte)50, (byte)49};
         SecretKeyFactory factory = SecretKeyFactory.getInstance("PBKDF2WithHmacSHA1");
         PBEKeySpec decryptedData1 = new PBEKeySpec(decryptedData.toCharArray(), cipher, 1024, 128);
         SecretKeySpec decryptedData2 = new SecretKeySpec(factory.generateSecret(decryptedData1).getEncoded(), "AES");
         Cipher cipher1;
         (cipher1 = Cipher.getInstance("AES/CTR/PKCS5Padding", "BC")).init(2, decryptedData2, new IvParameterSpec(iv));
         byte[] decryptedData3 = cipher1.doFinal(Base64.decodeBase64(aDecryptingData.getBytes("UTF-8")));
         return new String(decryptedData3);
      } else {
         return null;
      }
   }

   public static String decryptDataFromExternal(String aKey, String aDecryptingData) throws Exception {
      return null;
   }

   public static void main(String[] decryptedText) {
      try {
         String decryptedText1 = "Life";
         String encryptedText = "hello world!";
         System.out.println("plainedText: \n".concat(String.valueOf(encryptedText)));
         encryptedText = encryptData(decryptedText1, encryptedText);
         System.out.println("encryptedText: \n".concat(String.valueOf(encryptedText)));
         decryptedText1 = decryptData(decryptedText1, encryptedText);
         System.out.println("decryptedText: \n".concat(String.valueOf(decryptedText1)));
      } catch (Exception var2) {
         var2.printStackTrace();
      }
   }
}
